<template>
  <b-container fluid="lg">
    <div class="createPost-container">
      <div>
        <b-form ref="postForm" :model="postForm" :rules="rules">
          <b-row class="w-100 mb-2">
            <b-col sm="3">
              <b-row class="w-100">
                <b-col class="text-right" sm="12" md="12" lg="3">
                  <label>
                    {{ $t('form.province') }}
                  </label>
                </b-col>
                <b-col sm="12" md="12" lg="9">
                  <b-form-input
                    id="input-1"
                    v-model="postForm.province"
                    class="ml-2 mr-2"
                    required
                    :placeholder="$t('form.province')"
                  >&nbsp;</b-form-input>
                </b-col>
              </b-row>
            </b-col>
            <b-col sm="4">
              <b-row class="w-100">
                <b-col class="text-right" sm="12" md="12" lg="4">
                  <label>
                    {{ $t('form.city') }}
                  </label>
                </b-col>
                <b-col sm="12" md="12" lg="8">
                  <b-form-input
                    id="input-1"
                    v-model="postForm.city"
                    class="ml-2 mr-2"
                    required
                    :placeholder="$t('form.city')"
                  >&nbsp;</b-form-input>
                </b-col>
              </b-row>
            </b-col>
            <b-col sm="4">
              <b-row class="w-100">
                <b-col class="text-right" sm="12" md="12" lg="3">
                  <label>
                    {{ $t('form.region') }}
                  </label>
                </b-col>
                <b-col sm="12" md="12" lg="9">
                  <b-form-input
                    id="input-1"
                    v-model="postForm.region"
                    class="ml-2 mr-2"
                    required
                    :placeholder="$t('form.region')"
                  >&nbsp;</b-form-input>
                </b-col>
              </b-row>
            </b-col>
            <b-col sm="1">&nbsp;</b-col>
          </b-row>

          <b-row class="w-100 mb-2">
            <b-col sm="3">
              <b-row class="w-100">
                <b-col class="text-right" sm="12" md="12" lg="3">
                  <label>
                    {{ $t('form.address') }}
                  </label>
                </b-col>
                <b-col sm="12" md="12" lg="9">
                  <b-form-input
                    id="input-1"
                    v-model="postForm.address"
                    class="ml-2 mr-2"
                    required
                    :placeholder="$t('form.address')"
                  >&nbsp;</b-form-input>
                </b-col>
              </b-row>
            </b-col>
            <b-col sm="4">
              <b-row class="w-100">
                <b-col class="text-right" sm="12" md="12" lg="4">
                  <label>
                    {{ $t('form.geoPlace') }}
                  </label>
                </b-col>
                <b-col sm="12" md="12" lg="8">
                  <b-form-input
                    id="input-1"
                    v-model="postForm.geo_place"
                    class="ml-2 mr-2"
                    required
                    :placeholder="$t('form.geoPlace')"
                  >&nbsp;</b-form-input>
                </b-col>
              </b-row>
            </b-col>
            <b-col sm="4">
              <b-row class="w-100">
                <b-col sm="12" md="12" lg="3">
                  <label class="text-right">
                    {{ $t('form.rowColumn') }}
                  </label>
                </b-col>
                <b-col sm="12" md="12" lg="9">
                  <b-form-select
                    v-model="postForm.row"
                    :options="optionsRowColumn"
                    :placeholder="$t('form.row')"
                  >&nbsp;</b-form-select>
                  <b-form-select
                    v-model="postForm.column"
                    :options="optionsRowColumn"
                    :placeholder="$t('form.column')"
                  >&nbsp;</b-form-select>
                </b-col>
              </b-row>
            </b-col>
            <b-col sm="1">
              <b-button type="submit" variant="primary" @click.prevent.stop="submitForm">{{ $t('form.submit') }}</b-button>
            </b-col>
          </b-row>
        </b-form>
      </div>
    </div>
  </b-container>
</template>

<script>
import Address from '@/api/address';
import i18n from '@/lang';

const addressApi = new Address('address');
const defaultForm = {
  address: '',
  geoPlace: '',
  id: undefined,
};

export default {
  name: 'AddressDetail',

  components: {},
  props: {
    isEdit: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    const validateRequire = (rule, value, callback) => {
      if (value === '') {
        this.$message({
          message: rule.field + ' is required',
          type: 'error',
        });
        callback(new Error(rule.field + ' is required'));
      } else {
        callback();
      }
    };
    return {
      postForm: {
        address: '',
        geoPlace: '',
      },
      loading: false,
      userListOptions: [],
      rules: {
        address: [{ validator: validateRequire }],
      },
      optionsRowColumn: [
        { value: 1, text: 1 }, { value: 2, text: 2 }, { value: 3, text: 3 }, { value: 4, text: 4 },
        { value: 5, text: 5 }, { value: 6, text: 6 }, { value: 7, text: 7 }, { value: 8, text: 8 },
      ],
      options: [
        { value: 'new', text: this.$i18n.t(`form.newCounter`) },
        { value: 'old', text: this.$i18n.t(`form.oldCounter`) },
      ],
      tempRoute: {},
    };
  },
  computed: {
    contentShortLength() {
      return this.postForm.content_short.length;
    },
    lang() {
      return this.$store.getters.language;
    },
  },
  created() {
    if (this.isEdit) {
      const id = this.$route.params && this.$route.params.id;
      this.fetchData(id);
    } else {
      this.postForm = Object.assign({}, defaultForm);
    }

    // Why need to make a copy of this.$route here?
    // Because if you enter this page and quickly switch tag, may be in the execution of the setTagsViewTitle function, this.$route is no longer pointing to the current page
    this.tempRoute = Object.assign({}, this.$route);
  },
  methods: {
    onSubmit() {
      this.$message('submit!');
    },
    onCancel() {
      this.$message({
        message: 'cancel!',
        type: 'warning',
      });
    },
    fetchData(id) {
      addressApi(id)
        .then(response => {
          this.postForm = response.data;
          // Just for test
          this.postForm.title += `   Article Id:${this.postForm.id}`;
          this.postForm.content_short += `   Article Id:${this.postForm.id}`;
        })
        .catch(err => {
          console.log(err);
        });
    },
    submitForm() {
      this.loading = true;
      addressApi
        .store(this.postForm)
        .then(response => {
          this.$message({
            message: i18n.t(`field.created`),
            type: 'success',
            duration: 5 * 1000,
          });
          this.$router.push('/address/' + response.address + '/counters');
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.userCreating = false;
        });
    },
  },
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import "~@/styles/mixin.scss";
.createPost-container {
  position: relative;
  .createPost-main-container {
    padding: 0 45px 20px 50px;
    .postInfo-container {
      position: relative;
      @include clearfix;
      margin-bottom: 10px;
      .postInfo-container-item {
        float: left;
      }
    }
  }
  .word-counter {
    width: 40px;
    position: absolute;
    right: -10px;
    top: 0px;
  }
}
</style>
<style>
.createPost-container label.el-form-item__label {
  text-align: left;
}
</style>
